# Parallel-RI, Parallel Executable Binary to Wrap RIblast
This binary provides a CPU multithreaded wrapper of RIblast. 
In addition to the original options of RIblast, you can pass additional options such as a num. of threads and a path to RIblast. 
You must notice the IO options of RIblast have been changed into the new ones.
You can check all the available options by adding a option, "-h". 

# Installation
This project has been written by Rust, a system programming language.
So first you need to install a Rust compiler (Rustc), Rust package manager (Cargo) and Rust standard library. 
Please visit [a Rust homepage](https://www.rust-lang.org) to see more about Rust.
You can install Rustc, Cargo and Rust standard library with one line as follows:
```bash
$ curl https://sh.rustup.rs -sSf | sh -s -- --default-toolchain nightly
```
The above installation is done by [Rustup](https://github.com/rust-lang-nursery/rustup.rs), so you can easily switch a compiler to use. 
The nightly compiler enbles to test and benchmark on Rust.
If you don't need them, switch to the stable one as follows: 
```bash
$ rustup default stable
```
So you can install Parallel-RI as follows: 
```bash
$ cargo install --git https://github.com/heartsh/prll-ri
```
Check if Parallel-RI has been installed properly as follows: 
```bash
$ prll-ri
```
If you're interested in how much faster Parallel-RI is, run a benchmark as follows: 
```bash
$ git clone https://github.com/heartsh/prll-ri && cd prll-ri
$ cargo test -- --nocapture
```
If you use low performance disks such as HDDs, consider to install this repo.'s RIblast improved on IO performance. 

# Author
[Heartsh](https://github.com/heartsh)

# License
Copyright (c) 2016 Heartsh  
Licensed under [the MIT license](http://opensource.org/licenses/MIT).
